# neuro.pl -- the neuroprose gateway
#
# $Id: neuro.pl,v 2.1 1993/05/23 23:48:04 sanders Exp $
#
# Examples:
$map{'neuroprose'} = '&gen_neuroprose($query)';

sub gen_neuroprose {
    local($keywords) = @_;

    if($keywords) {
	&siks("$http_home/neuroprose/index.packed", "Neuroprose Archive",
	      "display_neuroprose", '<DL>', '</DL>', $keywords);
    } else {
	open(COVER, "$http_home/neuroprose/cover.html") ||
	    &error('not_implemented', "Cannot open cover page: $!");
	while(<COVER>) { print; alarm($http_timeout); }
	close(COVER);
    }
}


sub display_neuroprose {
    local($line) = @_;

    local($filename, $description, @authors) = split(/~/, $line);
    if(!defined $label) { $label = 1; }

    print '<DT>';
    print '<A NAME=', $label++, ' HREF="file://archive.cis.ohio-state.edu/pub/neuroprose/',  $filename, '">', $filename, '</A> ';

    foreach $author (@authors) {
	print " contact: ";
	local($user, $site) = ($author =~ /(\S+)@(\S+)/);
	print '<A NAME=', $label++, ' HREF="/finger/', $site, '/', $user, '">', $author,
	'</A> ';
    }
    print "\n";
    print '<DD>', $description, "\n";
}

1;
