# mkgray.pl -- gateway to weather
#
# Matthew Gray (mkgray@athena.mit.edu)
#

$map{'weather'} = '&do_weather("$rest?$query")';
require "$http_sdir/gweather.pl";

sub do_weather {
    local($args, $cmd) = @_;
    $args =~ s/\+/ /g;
    $args =~ m,\?(.+),;
    $station =$1;
    if($station){
	print "<isindex>".&get_weather($station)."</pre>";
    }
    else{
	alarm($time_out);
	print "<ISINDEX><TITLE>Weather</TITLE>\n";
	print "<h1>Weather</H1>\n";
	print "<P>";
	print("This is the new, barely tested weather gateway.\n");
	print("If you find any bugs, send mail to webmaster@athena or\n");
	print("enter <a href=\"http://www.mit.edu:8001/comment\">short comments here</a>\n");
	print("<p>If you know the city code of the forecast you want,\n");
	print("enter it in the search field\n");
	print "<h2><A HREF=\"usa.html\">Click here for current weather map and forecasts across the nation</A></h2><P>";
	print "<h2><A HREF=\"weather?bos\">Press here for Boston forecast</A></h2><P>";
    alarm(0);
}
}
