# front.pl -- process incoming requests
#
# $Id: front.pl,v 2.1 1993/05/23 23:47:58 sanders Exp $
#
# by Tony Sanders <sanders@bsdi.com>, May 1993
#

#
# NOTE: we export %in_headers, %out_headers from this point
#

sub process_input {
    local($method, $uri, $version, $waste) = split(" ", $_, 4);
    local(*in_headers, *out_headers);
    $method =~ y/A-Z/a-z/;			# XXX: $version =~ y/A-Z/a-z/;
    &error('not_implemented', "Invalid Method: $method")
        unless (defined $method{$method});
    &parse_headers(*in_headers) if $version;	# XXX: =~ m/$htrq_version/i;
    eval "&$method{$method}(\$uri, \$version)";
}

1;
