# account.pl -- restricted access directory
#
# $Id: account.pl,v 2.1 1993/05/23 23:47:49 sanders Exp $
#
# Tony Sanders <sanders@bsdi.com>, April 1993
#
# store $acct{$acctid} = $IP_Address;
# extend to support netmasks and lists of ip addresses
# extend to support hostnames and domains
#
# Examples:
# $map{'forsale'} = '&do_account($top, $rest, $query)';
#

do 'sys/socket.ph';
eval 'sub AF_INET {2;}'         unless defined &AF_INET;
eval 'sub SOCK_STREAM {1;}'     unless defined &SOCK_STREAM;
$sockaddr = 'S n a4 x8';

sub do_account {
    local($acct_db, $top, $rest, $query) = @_;
    local($db) = "$top/$acct_db";
    local(@path) = split('/', $rest);
    local($acctn) = shift @path;
    local($path) = $top . '/' . join('/', @path);
    local($id) = (unpack($sockaddr, getpeername(NS)))[2];
    &acct_verify($db, $acctn, $id);			# exits on failure
    &retrieve($path, $query);
}

sub acct_verify {
    local($db, $acctn, $id) = @_;
    local(%acct, $ok);
    -f "$db.db" || &error('bad_request', 'Access failed');
    dbmopen(%acct, $db, 0644) || &error('internal_error', 'Access failed');
    $ok = ($acct{$acctn} eq $id);			# XXX Fix me
    dbmclose(%acct);
    $ok || &error('payment_required', 'Access failed');
}

1;
