require "$http_sdir/gweather.pl";

sub do_usmap {
    local($args) = @_;
    local($x, $y) = split(',', substr($args, 1));

    @name = ('BOS','LAX','MCO','TOP','NYC','SLC','BWI','FTW','CHI','NEW',
	     'DSM','DEN','MEM','PHX','SEA');
    @x = (750,100,675,440,700,225,700,400,550,500,475,300,600,200,150);
    @y = (175,325,475,320,200,250,250,450,250,475,260,300,350,375,100);

    $min = 1000000;
    foreach $n (0..$#x){
	$locale = $name[$n];
	if(($dist=&distance($x, $y, $x[$n], $y[$n])) < $min){
	    $min = $dist;
	    $whereami = $locale;
	}
	    $out .= "From here to $locale: $dist\n";
    }

    alarm($time_out);
    print("<title>Nearest Weather Station is $whereami</title><isindex>\n");
    print &get_weather($whereami)."</pre>";
    alarm(0);
}
sub distance {
    local($x1, $y1, $x2, $y2) = @_;
    local($xd) = (($x1-$x2)*($x1-$x2));
    local($sqd)=$xd + (($y1-$y2)*($y1-$y2));
    $sqd;
}

1;


